diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.cc ns-3.34/src/wifi/model/wifi-phy.cc
--- ns-3.33/src/wifi/model/wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -1435,358 +1133,330 @@
   return m_standard;
 }
 
+const WifiPhyOperatingChannel&
+WifiPhy::GetOperatingChannel (void) const
+{
+  return m_operatingChannel;
+}
+
 void
 WifiPhy::SetFrequency (uint16_t frequency)
 {
   NS_LOG_FUNCTION (this << frequency);
-  if (m_isConstructed == false)
+
+  if (!m_operatingChannel.IsSet ())
     {
+      // ConfigureStandardAndBand has not been called yet, so store the frequency
+      // into m_initialFrequency
       NS_LOG_DEBUG ("Saving frequency configuration for initialization");
       m_initialFrequency = frequency;
       return;
     }
+
   if (GetFrequency () == frequency)
     {
       NS_LOG_DEBUG ("No frequency change requested");
       return;
     }
-  if (frequency == 0)
+
+  // if the frequency does not uniquely identify an operating channel,
+  // the simulation aborts
+  SetOperatingChannel (0, frequency, 0);
+}
+
+uint16_t
+WifiPhy::GetFrequency (void) const
+{
+  return m_operatingChannel.GetFrequency ();
+}
+
+void
+WifiPhy::SetChannelNumber (uint8_t nch)
+{
+  NS_LOG_FUNCTION (this << +nch);
+
+  if (!m_operatingChannel.IsSet ())
     {
-      DoFrequencySwitch (0);
-      NS_LOG_DEBUG ("Setting frequency and channel number to zero");
-      m_channelCenterFrequency = 0;
-      m_channelNumber = 0;
+      // ConfigureStandardAndBand has not been called yet, so store the channel
+      // into m_initialChannelNumber
+      NS_LOG_DEBUG ("Saving channel number configuration for initialization");
+      m_initialChannelNumber = nch;
       return;
     }
-  // If the user has configured both Frequency and ChannelNumber, Frequency
-  // takes precedence.  Lookup the channel number corresponding to the
-  // requested frequency.
-  uint8_t nch = FindChannelNumberForFrequencyWidth (frequency, GetChannelWidth ());
-  if (nch != 0)
-    {
-      NS_LOG_DEBUG ("Setting frequency " << frequency << " corresponds to channel " << +nch);
-      if (DoFrequencySwitch (frequency))
-        {
-          NS_LOG_DEBUG ("Channel frequency switched to " << frequency << "; channel number to " << +nch);
-          m_channelCenterFrequency = frequency;
-          m_channelNumber = nch;
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Suppressing reassignment of frequency");
-        }
-    }
-  else
+
+  if (GetChannelNumber () == nch)
     {
-      NS_LOG_DEBUG ("Channel number is unknown for frequency " << frequency);
-      if (DoFrequencySwitch (frequency))
-        {
-          NS_LOG_DEBUG ("Channel frequency switched to " << frequency << "; channel number to " << 0);
-          m_channelCenterFrequency = frequency;
-          m_channelNumber = 0;
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Suppressing reassignment of frequency");
-        }
+      NS_LOG_DEBUG ("No channel change requested");
+      return;
     }
+
+  // if the channel number does not uniquely identify an operating channel,
+  // the simulation aborts
+  SetOperatingChannel (nch, 0, 0);
 }
 
-uint16_t
-WifiPhy::GetFrequency (void) const
+uint8_t
+WifiPhy::GetChannelNumber (void) const
 {
-  return m_channelCenterFrequency;
+  return m_operatingChannel.GetNumber ();
 }
 
 void
 WifiPhy::SetChannelWidth (uint16_t channelWidth)
 {
   NS_LOG_FUNCTION (this << channelWidth);
-  NS_ASSERT_MSG (channelWidth == 5 || channelWidth == 10 || channelWidth == 20 || channelWidth == 22 || channelWidth == 40 || channelWidth == 80 || channelWidth == 160, "wrong channel width value");
-  bool changed = (m_channelWidth != channelWidth);
-  m_channelWidth = channelWidth;
-  AddSupportedChannelWidth (channelWidth);
-  if (changed && !m_capabilitiesChangedCallback.IsNull ())
+
+  if (channelWidth != 0)
     {
-      m_capabilitiesChangedCallback ();
+      AddSupportedChannelWidth (channelWidth);
+    }
+
+  if (!m_operatingChannel.IsSet ())
+    {
+      // ConfigureStandardAndBand has not been called yet, so store the channel width
+      // into m_initialChannelWidth
+      NS_LOG_DEBUG ("Saving channel width configuration for initialization");
+      m_initialChannelWidth = channelWidth;
+      return;
+    }
+
+  if (GetChannelWidth () == channelWidth)
+    {
+      NS_LOG_DEBUG ("No channel width change requested");
+      return;
     }
+
+  NS_ABORT_MSG ("The channel width does not uniquely identify an operating channel.");
 }
 
 uint16_t
 WifiPhy::GetChannelWidth (void) const
 {
-  return m_channelWidth;
+  return m_operatingChannel.GetWidth ();
 }
 
 void
-WifiPhy::SetNumberOfAntennas (uint8_t antennas)
+WifiPhy::SetPrimary20Index (uint8_t index)
 {
-  NS_ASSERT_MSG (antennas > 0 && antennas <= 4, "unsupported number of antennas");
-  m_numberOfAntennas = antennas;
-  m_interference.SetNumberOfReceiveAntennas (antennas);
-}
+  NS_LOG_FUNCTION (this << +index);
 
-uint8_t
-WifiPhy::GetNumberOfAntennas (void) const
-{
-  return m_numberOfAntennas;
-}
-
-void
-WifiPhy::SetMaxSupportedTxSpatialStreams (uint8_t streams)
-{
-  NS_ASSERT (streams <= GetNumberOfAntennas ());
-  bool changed = (m_txSpatialStreams != streams);
-  m_txSpatialStreams = streams;
-  ConfigureHtDeviceMcsSet ();
-  if (changed && !m_capabilitiesChangedCallback.IsNull ())
+  if (!m_operatingChannel.IsSet ())
     {
-      m_capabilitiesChangedCallback ();
+      // ConfigureStandardAndBand has not been called yet, so store the primary20
+      // index into m_initialPrimary20Index
+      NS_LOG_DEBUG ("Saving primary20 index configuration for initialization");
+      m_initialPrimary20Index = index;
+      return;
     }
-}
 
-uint8_t
-WifiPhy::GetMaxSupportedTxSpatialStreams (void) const
-{
-  return m_txSpatialStreams;
+  m_operatingChannel.SetPrimary20Index (index);
 }
 
 void
-WifiPhy::SetMaxSupportedRxSpatialStreams (uint8_t streams)
-{
-  NS_ASSERT (streams <= GetNumberOfAntennas ());
-  bool changed = (m_rxSpatialStreams != streams);
-  m_rxSpatialStreams = streams;
-  if (changed && !m_capabilitiesChangedCallback.IsNull ())
-    {
-      m_capabilitiesChangedCallback ();
-    }
-}
-
-uint8_t
-WifiPhy::GetMaxSupportedRxSpatialStreams (void) const
-{
-  return m_rxSpatialStreams;
-}
-
-uint8_t
-WifiPhy::GetNBssMembershipSelectors (void) const
-{
-  return static_cast<uint8_t> (m_bssMembershipSelectorSet.size ());
-}
-
-uint8_t
-WifiPhy::GetBssMembershipSelector (uint8_t selector) const
+WifiPhy::SetOperatingChannel (uint8_t number, uint16_t frequency, uint16_t width)
 {
-  return m_bssMembershipSelectorSet[selector];
-}
+  Time delay = Seconds (0);
 
-void
-WifiPhy::AddSupportedChannelWidth (uint16_t width)
-{
-  NS_LOG_FUNCTION (this << width);
-  for (std::vector<uint32_t>::size_type i = 0; i != m_supportedChannelWidthSet.size (); i++)
+  if (IsInitialized ())
     {
-      if (m_supportedChannelWidthSet[i] == width)
-        {
-          return;
-        }
+      delay = DoChannelSwitch ();
     }
-  NS_LOG_FUNCTION ("Adding " << width << " to supported channel width set");
-  m_supportedChannelWidthSet.push_back (width);
-}
-
-std::vector<uint16_t>
-WifiPhy::GetSupportedChannelWidthSet (void) const
-{
-  return m_supportedChannelWidthSet;
-}
-
-WifiPhy::FrequencyWidthPair
-WifiPhy::GetFrequencyWidthForChannelNumberStandard (uint8_t channelNumber, WifiPhyBand band, WifiPhyStandard standard) const
-{
-  ChannelNumberStandardPair p = std::make_pair (std::make_pair (channelNumber, band), standard);
-  FrequencyWidthPair f = m_channelToFrequencyWidth[p];
-  return f;
-}
 
-void
-WifiPhy::SetChannelNumber (uint8_t nch)
-{
-  NS_LOG_FUNCTION (this << +nch);
-  if (m_isConstructed == false)
-    {
-      NS_LOG_DEBUG ("Saving channel number configuration for initialization");
-      m_initialChannelNumber = nch;
-      return;
-    }
-  if (GetChannelNumber () == nch)
+  if (delay.IsStrictlyNegative ())
     {
-      NS_LOG_DEBUG ("No channel change requested");
+      // switching channel is not possible now
       return;
     }
-  if (nch == 0)
+  if (delay.IsStrictlyPositive ())
     {
-      // This case corresponds to when there is not a known channel
-      // number for the requested frequency.  There is no need to call
-      // DoChannelSwitch () because DoFrequencySwitch () should have been
-      // called by the client
-      NS_LOG_DEBUG ("Setting channel number to zero");
-      m_channelNumber = 0;
+      // switching channel has been postponed
+      Simulator::Schedule (delay, &WifiPhy::SetOperatingChannel, this, number, frequency, width);
       return;
     }
 
-  // First make sure that the channel number is defined for the standard in use
-  FrequencyWidthPair f = GetFrequencyWidthForChannelNumberStandard (nch, GetPhyBand (), GetPhyStandard ());
-  if (f.first == 0)
+  // channel can be switched now.
+  uint16_t prevChannelWidth = 0;
+  if (m_operatingChannel.IsSet ())
     {
-      f = GetFrequencyWidthForChannelNumberStandard (nch, GetPhyBand (), WIFI_PHY_STANDARD_UNSPECIFIED);
+      prevChannelWidth = GetChannelWidth ();
     }
-  if (f.first != 0)
+
+  m_operatingChannel.Set (number, frequency, width, m_standard, m_band);
+
+  if (GetChannelWidth () != prevChannelWidth)
     {
-      if (DoChannelSwitch (nch))
-        {
-          NS_LOG_DEBUG ("Setting frequency to " << f.first << "; width to " << +f.second);
-          m_channelCenterFrequency = f.first;
-          SetChannelWidth (f.second);
-          m_channelNumber = nch;
-        }
-      else
+      AddSupportedChannelWidth (GetChannelWidth ());
+
+      // If channel width changed after initialization, invoke the capabilities changed callback
+      if (IsInitialized () && !m_capabilitiesChangedCallback.IsNull ())
         {
-          // Subclass may have suppressed (e.g. waiting for state change)
-          NS_LOG_DEBUG ("Channel switch suppressed");
+          m_capabilitiesChangedCallback ();
         }
     }
-  else
-    {
-      NS_FATAL_ERROR ("Frequency not found for channel number " << +nch);
-    }
-}
-
-uint8_t
-WifiPhy::GetChannelNumber (void) const
-{
-  return m_channelNumber;
 }
 
-bool
-WifiPhy::DoChannelSwitch (uint8_t nch)
+Time
+WifiPhy::DoChannelSwitch (void)
 {
   m_powerRestricted = false;
   m_channelAccessRequested = false;
+  m_currentEvent = 0;
+  m_currentPreambleEvents.clear ();
   if (!IsInitialized ())
     {
       //this is not channel switch, this is initialization
-      NS_LOG_DEBUG ("initialize to channel " << +nch);
-      return true;
+      NS_LOG_DEBUG ("Before initialization, nothing to do");
+      return Seconds (0);
     }
 
+  Time delay = Seconds (0);
+
   NS_ASSERT (!IsStateSwitching ());
   switch (m_state->GetState ())
     {
     case WifiPhyState::RX:
       NS_LOG_DEBUG ("drop packet because of channel switching while reception");
       m_endPhyRxEvent.Cancel ();
-      m_endRxEvent.Cancel ();
-      m_endPreambleDetectionEvent.Cancel ();
-      goto switchChannel;
+      for (auto & phyEntity : m_phyEntities)
+        {
+          phyEntity.second->CancelAllEvents ();
+        }
       break;
     case WifiPhyState::TX:
       NS_LOG_DEBUG ("channel switching postponed until end of current transmission");
-      Simulator::Schedule (GetDelayUntilIdle (), &WifiPhy::SetChannelNumber, this, nch);
+      delay = GetDelayUntilIdle ();
       break;
     case WifiPhyState::CCA_BUSY:
     case WifiPhyState::IDLE:
-      if (m_endPreambleDetectionEvent.IsRunning ())
+      for (auto & phyEntity : m_phyEntities)
         {
-          m_endPreambleDetectionEvent.Cancel ();
-          m_endRxEvent.Cancel ();
+          phyEntity.second->CancelAllEvents ();
         }
-      goto switchChannel;
       break;
     case WifiPhyState::SLEEP:
       NS_LOG_DEBUG ("channel switching ignored in sleep mode");
+      delay = Seconds (-1);  // negative value to indicate switching not possible
       break;
     default:
       NS_ASSERT (false);
       break;
     }
 
-  return false;
+  if (delay.IsZero ())
+    {
+      // channel switch can be done now
+      NS_LOG_DEBUG ("switching channel");
+      m_state->SwitchToChannelSwitching (GetChannelSwitchDelay ());
+      m_interference.EraseEvents ();
+      /*
+      * Needed here to be able to correctly sensed the medium for the first
+      * time after the switching. The actual switching is not performed until
+      * after m_channelSwitchDelay. Packets received during the switching
+      * state are added to the event list and are employed later to figure
+      * out the state of the medium after the switching.
+      */
+    }
 
-switchChannel:
+  return delay;
+}
 
-  NS_LOG_DEBUG ("switching channel " << +GetChannelNumber () << " -> " << +nch);
-  m_state->SwitchToChannelSwitching (GetChannelSwitchDelay ());
-  m_interference.EraseEvents ();
-  /*
-   * Needed here to be able to correctly sensed the medium for the first
-   * time after the switching. The actual switching is not performed until
-   * after m_channelSwitchDelay. Packets received during the switching
-   * state are added to the event list and are employed later to figure
-   * out the state of the medium after the switching.
-   */
-  return true;
+void
+WifiPhy::SetNumberOfAntennas (uint8_t antennas)
+{
+  NS_ASSERT_MSG (antennas > 0 && antennas <= 4, "unsupported number of antennas");
+  m_numberOfAntennas = antennas;
+  m_interference.SetNumberOfReceiveAntennas (antennas);
 }
 
-bool
-WifiPhy::DoFrequencySwitch (uint16_t frequency)
+uint8_t
+WifiPhy::GetNumberOfAntennas (void) const
 {
-  m_powerRestricted = false;
-  m_channelAccessRequested = false;
-  if (!IsInitialized ())
+  return m_numberOfAntennas;
+}
+
+void
+WifiPhy::SetMaxSupportedTxSpatialStreams (uint8_t streams)
+{
+  NS_ASSERT (streams <= GetNumberOfAntennas ());
+  bool changed = (m_txSpatialStreams != streams);
+  m_txSpatialStreams = streams;
+  if (changed)
     {
-      //this is not channel switch, this is initialization
-      NS_LOG_DEBUG ("start at frequency " << frequency);
-      return true;
+      auto phyEntity = m_phyEntities.find (WIFI_MOD_CLASS_HT);
+      if (phyEntity != m_phyEntities.end ())
+        {
+          Ptr<HtPhy> htPhy = DynamicCast<HtPhy> (phyEntity->second);
+          if (htPhy)
+            {
+              htPhy->SetMaxSupportedNss (m_txSpatialStreams); //this is essential to have the right MCSs configured
+            }
+
+          if (!m_capabilitiesChangedCallback.IsNull ())
+            {
+              m_capabilitiesChangedCallback ();
+            }
+        }
     }
+}
 
-  NS_ASSERT (!IsStateSwitching ());
-  switch (m_state->GetState ())
+uint8_t
+WifiPhy::GetMaxSupportedTxSpatialStreams (void) const
+{
+  return m_txSpatialStreams;
+}
+
+void
+WifiPhy::SetMaxSupportedRxSpatialStreams (uint8_t streams)
+{
+  NS_ASSERT (streams <= GetNumberOfAntennas ());
+  bool changed = (m_rxSpatialStreams != streams);
+  m_rxSpatialStreams = streams;
+  if (changed && !m_capabilitiesChangedCallback.IsNull ())
     {
-    case WifiPhyState::RX:
-      NS_LOG_DEBUG ("drop packet because of channel/frequency switching while reception");
-      m_endPhyRxEvent.Cancel ();
-      m_endRxEvent.Cancel ();
-      m_endPreambleDetectionEvent.Cancel ();
-      goto switchFrequency;
-      break;
-    case WifiPhyState::TX:
-      NS_LOG_DEBUG ("channel/frequency switching postponed until end of current transmission");
-      Simulator::Schedule (GetDelayUntilIdle (), &WifiPhy::SetFrequency, this, frequency);
-      break;
-    case WifiPhyState::CCA_BUSY:
-    case WifiPhyState::IDLE:
-      if (m_endPreambleDetectionEvent.IsRunning ())
+      m_capabilitiesChangedCallback ();
+    }
+}
+
+uint8_t
+WifiPhy::GetMaxSupportedRxSpatialStreams (void) const
+{
+  return m_rxSpatialStreams;
+}
+
+std::list<uint8_t>
+WifiPhy::GetBssMembershipSelectorList (void) const
+{
+  std::list<uint8_t> list;
+  for (const auto & phyEntity : m_phyEntities)
+    {
+      Ptr<HtPhy> htPhy = DynamicCast<HtPhy> (phyEntity.second);
+      if (htPhy)
         {
-          m_endPreambleDetectionEvent.Cancel ();
-          m_endRxEvent.Cancel ();
+          list.emplace_back (htPhy->GetBssMembershipSelector ());
         }
-      goto switchFrequency;
-      break;
-    case WifiPhyState::SLEEP:
-      NS_LOG_DEBUG ("frequency switching ignored in sleep mode");
-      break;
-    default:
-      NS_ASSERT (false);
-      break;
     }
+  return list;
+}
 
-  return false;
-
-switchFrequency:
+void
+WifiPhy::AddSupportedChannelWidth (uint16_t width)
+{
+  NS_LOG_FUNCTION (this << width);
+  for (std::vector<uint32_t>::size_type i = 0; i != m_supportedChannelWidthSet.size (); i++)
+    {
+      if (m_supportedChannelWidthSet[i] == width)
+        {
+          return;
+        }
+    }
+  NS_LOG_FUNCTION ("Adding " << width << " to supported channel width set");
+  m_supportedChannelWidthSet.push_back (width);
+}
 
-  NS_LOG_DEBUG ("switching frequency " << GetFrequency () << " -> " << frequency);
-  m_state->SwitchToChannelSwitching (GetChannelSwitchDelay ());
-  m_interference.EraseEvents ();
-  /*
-   * Needed here to be able to correctly sensed the medium for the first
-   * time after the switching. The actual switching is not performed until
-   * after m_channelSwitchDelay. Packets received during the switching
-   * state are added to the event list and are employed later to figure
-   * out the state of the medium after the switching.
-   */
-  return true;
+std::vector<uint16_t>
+WifiPhy::GetSupportedChannelWidthSet (void) const
+{
+  return m_supportedChannelWidthSet;
 }
 
 void
@@ -1830,9 +1500,11 @@
   m_powerRestricted = false;
   m_channelAccessRequested = false;
   m_endPhyRxEvent.Cancel ();
-  m_endRxEvent.Cancel ();
-  m_endPreambleDetectionEvent.Cancel ();
   m_endTxEvent.Cancel ();
+  for (auto & phyEntity : m_phyEntities)
+    {
+      phyEntity.second->CancelAllEvents ();
+    }
   m_state->SwitchToOff ();
 }
 
@@ -1840,6 +1512,7 @@
 WifiPhy::ResumeFromSleep (void)
 {
   NS_LOG_FUNCTION (this);
+  m_currentPreambleEvents.clear ();
   switch (m_state->GetState ())
     {
     case WifiPhyState::TX:
@@ -1854,8 +1527,7 @@
     case WifiPhyState::SLEEP:
       {
         NS_LOG_DEBUG ("resuming from sleep mode");
-        uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
-        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetBand (primaryChannelWidth));
+        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetPrimaryBand (GetMeasurementChannelWidth (nullptr)));
         m_state->SwitchFromSleep (delayUntilCcaEnd);
         break;
       }
@@ -1886,8 +1558,7 @@
     case WifiPhyState::OFF:
       {
         NS_LOG_DEBUG ("resuming from off mode");
-        uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
-        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetBand (primaryChannelWidth));
+        Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetPrimaryBand (GetMeasurementChannelWidth (nullptr)));
         m_state->SwitchFromOff (delayUntilCcaEnd);
         break;
       }
